#ifndef __IP_OUTPUT_H
#define __IP_OUTPUT_H


extern int _ip_id_increment;
extern int _default_ttl;
extern int _default_tos;

extern WORD _get_ip_id (void);
extern WORD _get_this_ip_id (void);

extern int _ip_output (in_Header *ip, DWORD src_ip, DWORD dst_ip,
                       WORD protocol, BYTE ttl, BYTE tos, int data_len,
                       const void *sock, const char *file, unsigned line);

#define IP_OUTPUT(ip, src, dst, proto, ttl, tos, data_len, sock) \
       _ip_output(ip, src, dst, proto, ttl, tos, data_len, sock, \
                  __FILE__, __LINE__)

extern int _chk_ip_header (const in_Header *ip);

struct frag_list {
       struct frag_list *next;
       in_Header        *ip;
       unsigned          len;
     };

#if defined(USE_FRAGMENTS)
  struct frag_list *ip_do_fragment  (sock_type *sk, const void *buf, int len);
  void              ip_free_fragment(struct frag_list *frag);
#endif

#endif
