#ifndef __LINK_LAYER_H
#define __LINK_LAYER_H

/*
 * Not used yet; idea is to cleanup the interface to the link-layer
 * whether it is PPP, Ethernet or Token-Ring (hopefully, but don't
 * have too high hopes. In the meantime use an Ether emulating TR
 * driver).
 */

/*
 * Bits for 'capabilities'
 */
#define IFF_BROADCAST  0x0001   /* broadcast address valid */
#define IFF_NOARP      0x0002   /* no address resolution protocol */
#define IFF_MULTICAST  0x0004   /* supports multicast */

#define MAX_LINK_ADDR  16       /* hm, should 6 be enough? */

typedef BYTE link_addr [MAX_LINK_ADDR];

struct link_layer {
       unsigned  capabilities; /* link-layer capabilities */
       unsigned  ip_dst_ofs;   /* ofs from ip-header to MAC destination (-14) */
       unsigned  ip_src_ofs;   /* ofs from ip-header to MAC source addr (-8) */
       unsigned  max_size;     /* max transmit unit     (1500) */
       unsigned  min_size;     /* min transmit unit     (60) */
       unsigned  addr_len;     /* length of MAC address (6) */
       unsigned  hdr_len;      /* length of MAC header  (14) */

       link_addr own_addr;
       link_addr bcast_addr;
     };

extern (*_link_layer_data)(void);

extern void *link_get_header  (const void *ip);
extern void *link_make_header (const link_addr *dest, WORD type);

#endif
