#ifndef __MISC_H
#define __MISC_H

/*
 * Fixup namespace for "internal" symbols
 */
#define cpu_type      NAMESPACE(cpu_type)
#define init_misc     NAMESPACE(init_misc)
#define Random        NAMESPACE(Random)
#define RandomWait    NAMESPACE(RandomWait)
#define valid_addr    NAMESPACE(valid_addr)
#define hex_chars     NAMESPACE(hex_chars)
#define hex_CHARS     NAMESPACE(hex_CHARS)


/*
 * Implemented in misc.c
 */

#include <sys/swap.h>

extern int __bss_count, cpu_type;

extern char hex_chars[];
extern char hex_CHARS[];

extern void init_misc (void);
extern int  Random    (unsigned a, unsigned b);
extern void RandomWait(unsigned a, unsigned b);

extern BOOL valid_addr(DWORD addr, int len);

#if defined(USE_DEBUG)  /* Mainly the PowerPak extender */
  extern void unfinished (const char *file, unsigned line);
  #define UNFINISHED() unfinished(__FILE__, __LINE__)
#else
  #define UNFINISHED() ((void)0)
#endif

#if defined(__LARGE__)
  extern void watt_largecheck (void *s, int size, char *file, unsigned line);
#else
  #define watt_largecheck(s,ss,f,l) ((void)0)
#endif

/*
 * Implemented in timer.c
 */
#define has_8254     NAMESPACE (has_8254)
#define has_rdtsc    NAMESPACE (has_rdtsc)
#define init_timers  NAMESPACE (init_timers)
#define set_timeout  NAMESPACE (set_timeout)
#define chk_timeout  NAMESPACE (chk_timeout)
#define cmp_timeout  NAMESPACE (cmp_timeout)
#define hires_timer  NAMESPACE (hires_timer)
#define set_timediff NAMESPACE (set_timediff)
#define get_timediff NAMESPACE (get_timediff)

#define time_str     NAMESPACE (time_str)
#define dword_str    NAMESPACE (dword_str)

#define timer_set    NAMESPACE (timer_set)
#define timer_clr    NAMESPACE (timer_clr)
#define timer_chk    NAMESPACE (timer_chk)
#define calltimeout  NAMESPACE (calltimeout)

extern int has_8254, has_rdtsc;

extern void  init_timers  (void);
extern DWORD set_timeout  (DWORD msec);        /* return value for timeout */
extern int   chk_timeout  (DWORD timeout);     /* check if time expired    */
extern int   cmp_timers   (DWORD t1, DWORD t2);
extern void  hires_timer  (int on);
extern int   set_timediff (long msec);
extern DWORD get_timediff (DWORD now, DWORD t);

extern const char *time_str  (DWORD val);
extern const char *dword_str (DWORD val);

extern int timer_set  (DWORD msec);
extern int timer_clr  (int timer);
extern int timer_chk  (int timer);
extern int calltimeout(void);

#if defined(HAVE_UINT64)
  #define microsec_clock NAMESPACE (microsec_clock)
  extern uint64 microsec_clock (void);
#endif

#endif /* __MISC_H */

