/*
 *   RARP - Boot Protocol (RFC 903)
 *
 *   These extensions get called if MY_IP is set to RARP in wattcp.cfg
 *
 *   Version
 *
 *   0.0 : Sept 6, 1996 : Copied from E. Engelke's pcbootp.c by Dan Kegel
 *   0.1 : Febr 9, 1997 : Modified, removed debug printing,  G. Vanem
 */

#include <stdio.h>
#include <string.h>

#include "copyrigh.h"
#include "wattcp.h"
#include "strings.h"
#include "language.h"
#include "misc.h"
#include "pcsed.h"
#include "pctcp.h"
#include "pcrarp.h"

WORD _rarptimeout = 15;

#if defined(USE_RARP)

static int _rarp_request (void)
{
  rarp_Header *op   = (rarp_Header*) _eth_formatpacket (&_eth_brdcast[0],
                                                        RARP_TYPE);
  op->hwType        = _pkttoken ? ARP_TYPE_TOKEN : ARP_TYPE_ETHER;
  op->protType      = IP_TYPE;
  op->hwProtAddrLen = sizeof (eth_address) + (sizeof(DWORD) << 8);
  op->opcode        = RARP_REQUEST;
  op->srcIPAddr     = 0;
  op->dstIPAddr     = 0;
  memcpy (op->srcEthAddr, _eth_addr, sizeof(eth_address));
  memcpy (op->dstEthAddr, _eth_addr, sizeof(eth_address));

  DEBUG_TX (NULL, op);
  return _eth_send (sizeof(*op));
}

/*
 * _dorarpc - Checks global variable _rarptimeout
 *            returns 1 on success and sets ip address
 */
int _dorarp (void)
{
  DWORD rarptimeout         = set_timeout (1000 * _rarptimeout);
  WORD  proto, magictimeout = Random (7000, 14000);
  BOOL  ether_broadcast     = FALSE;

  outs (_LANG("Configuring through RARP..."));

  while (1)
  {
    DWORD sendtimeout;

    if (!_rarp_request())
       return (0);

    sendtimeout = set_timeout (magictimeout);
    magictimeout += Random (1000, 7000);

    while (!chk_timeout(sendtimeout))
    {
      rarp_Header *rarp;

      if (chk_timeout(rarptimeout))
         goto quit;
      kbhit();

      rarp = (rarp_Header*) _eth_arrived (&proto,&ether_broadcast);
      if (rarp)
      {
        DEBUG_RX (NULL,rarp);
        if (proto == RARP_TYPE && !ether_broadcast &&
            rarp->opcode == RARP_REPLY)
        {
          my_ip_addr = intel (rarp->dstIPAddr);
          goto quit;
        }
      }
    }
  }

quit:
  return (my_ip_addr != 0);
}

#endif /* USE_RARP */

