/*
 * Link-layer (DIX Ethernet) Interface
 */

#ifndef __PCSED_H
#define __PCSED_H

extern WORD         _pktdevclass;
extern BYTE         _pktserial;
extern BYTE         _pkttoken;
extern BYTE         _pktdevlevel;
extern BYTE         _pkterror;
extern int          _pktretries;
extern BOOL         _ip_recursion;
extern BOOL         _eth_is_init;
extern eth_address  _eth_addr;
extern eth_address  _eth_brdcast;

#if defined(USE_MULTICAST)
  extern int _eth_join_mcast_group  (int entry);
  extern int _eth_leave_mcast_group (int entry);
#endif

extern int   _eth_init         (void);
extern void  _eth_release      (void);
extern int   _eth_send         (WORD len);
extern int   _eth_set_addr     (eth_address *eth);
extern BYTE *_eth_formatpacket (const void *eth_dest, WORD eth_type);
extern void  _eth_free         (const void *pkt, WORD type);
extern BYTE *_eth_arrived      (WORD *type, BOOL *brdcast);
extern void *_eth_hardware     (BYTE *p);

#endif
