#include <stdio.h>

typedef struct {
        unsigned eax;
        unsigned ebx;
        unsigned ecx;
        unsigned edx;
      } CPUIDDATA;

CPUIDDATA cpuid (int);

#pragma aux cpuid =  \
            ".586"   \
            "cpuid"  \
            "mov [esi],eax"    \
            "mov [esi+4],ebx"  \
            "mov [esi+8],ecx"  \
            "mov [esi+12],edx" \
            __modify [eax ebx ecx edx] __parm [eax];

int main (void)
{
  CPUIDDATA data;

  data = cpuid (0);
  printf ("Maximum value permitted for CPUID instruction = %u\n",
          data.eax);
  printf ("Signature = [%4.4s%4.4s%4.4s]\n",
          &data.ebx, &data.edx, &data.ecx);

  data = cpuid (1);
  printf ("CPU Family   = %u\n", (data.eax >> 8)  & 0xF);
  printf ("CPU Type     = %u\n", (data.eax >> 12) & 0xF);
  printf ("CPU Model    = %u\n", (data.eax >> 4)  & 0xF);
  printf ("CPU Stepping = %u\n", data.eax & 0xF);

  if (data.edx & 0x800000)
     puts ("MMX is available");

  return 0;
}
