#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

char  include[]  = "#include";
char *obj_prefix = "";

void usage (void)
{
  fprintf (stderr, "syntax: mkdep [-v] [-p obj-prefix] .c/.h-files | @resp\n");
  exit (0);
}

int main (int argc, char **argv)
{
  int   ch, idx;
  int   verb = 0;
  char *prog = argv[0];
  char *fname;

  while ((ch = getopt(argc,argv,"vp:")) != EOF)
     switch (ch)
     {
       case 'v': verb = 1;
                 break;
       case 'p': obj_prefix = optarg;
                 break;
       case '?':
       default:  usage();
     }

  argc -= optind;
  argv += optind;

  if (argc < 1)
     usage();

  printf ("#\n# This file is generated by %s. DO NOT EDIT\n#\n", prog);

  for (idx = 0; idx < argc && (fname = argv[idx]) != NULL; idx++)
  {
    char  buf[512], *ext;
    int   c_file, h_file;
    int   lvalue = 0;
    FILE *fin;

    if (verb)
       fprintf (stderr, "Opening file `%s'\n", fname);

    fin = fopen (fname, "r");
    if (!fin)
    {
      fprintf (stderr, "Cannot read `%s'\n", fname);
      return (0);
    }
    ext    = fname + strlen(fname) - 2;
    c_file = (strnicmp(ext,".c",2) == 0);
    h_file = (strnicmp(ext,".h",2) == 0);

    if (!c_file && !h_file)
    {
      fprintf (stderr, "`%s' is not a C or H-file\n", fname);
      return (0);
    }

    while (fgets(buf,sizeof(buf),fin))
    {
      char *cp, *cp1 = buf;

      while (*cp1 == ' ' || *cp1 == '\t') /* remove leading whitespace */
            cp1++;

      if (strncmp(cp1,include,sizeof(include)-1))    /* not "#include" */
         continue;

      if ((cp = strchr(cp1,'\"')) == NULL)
         continue;

      cp++;
      if ((cp1 = strchr(cp, '\"')) == NULL)
         continue;

      if (!strstr(cp,".h"))
         continue;

      if (!lvalue)
      {
        if (c_file)
             printf ("%s%.*s.$(O): %s", obj_prefix, (int)(ext-fname), fname, fname);
        else printf ("%s: ", fname);
        lvalue = 1;
      }
      *cp1 = '\0';
      printf (" %s", cp);
    }
    if (lvalue)
       putchar ('\n');
    fclose (fin);
  }
  return (0);
}
